Subject: Re: linux-next: build failure after merge of the bitmap tree

From: Miquel Raynal <[email-masked]>
Date: Fri, 28 Nov 2025 09:17:08 +0100

Hello,

>> Caused by commit
>>
>>   c1c6ab80b25c ("bitfield: Add non-constant field_{prep,get}() helpers")
>>
>> interacting with commits
>>
>>   d21b4338159f ("mtd: rawnand: sunxi: introduce ecc_mode_mask in sunxi_nfc_caps")
>>   6fc2619af1eb ("mtd: rawnand: sunxi: rework pattern found registers")
>>
>> from the nand tree.
>>
>> I have applied the following hack for today.
>>
>> From: Stephen Rothwell <[email-masked]>
>> Date: Tue, 25 Nov 2025 17:47:46 +1100
>> Subject: [PATCH] fix up for "bitfield: Add non-constant field_{prep,get}()
>>  helpers"
>>
>> interacting with commits
>>
>>   d21b4338159f ("mtd: rawnand: sunxi: introduce ecc_mode_mask in sunxi_nfc_caps")
>>   6fc2619af1eb ("mtd: rawnand: sunxi: rework pattern found registers")
>>
>> from the nand tree.
>>
>> Signed-off-by: Stephen Rothwell <[email-masked]>
>> ---
>>  drivers/mtd/nand/raw/sunxi_nand.c | 12 ++++++------
>>  1 file changed, 6 insertions(+), 6 deletions(-)
>>
>> diff --git a/drivers/mtd/nand/raw/sunxi_nand.c b/drivers/mtd/nand/raw/sunxi_nand.c
>> index 031ab651c5a8..b940eb5cf79a 100644
>> --- a/drivers/mtd/nand/raw/sunxi_nand.c
>> +++ b/drivers/mtd/nand/raw/sunxi_nand.c
>> @@ -30,8 +30,8 @@
>>  #include <linux/reset.h>
>>
>>  /* non compile-time field get/prep */
>> -#define field_get(_mask, _reg) (((_reg) & (_mask)) >> (ffs(_mask) - 1))
>> -#define field_prep(_mask, _val) (((_val) << (ffs(_mask) - 1)) & (_mask))
>> +#define sunxi_field_get(_mask, _reg) (((_reg) & (_mask)) >> (ffs(_mask) - 1))
>> +#define sunxi_field_prep(_mask, _val) (((_val) << (ffs(_mask) - 1)) & (_mask))
>
> See "[PATCH -next v6 11/26] mtd: rawnand: sunxi: #undef
> field_{get,prep}() before local definition"[1] and follow-up
> "[PATCH -next v6 24/26] mtd: rawnand: sunxi: Convert to common
> field_{get,prep}() helpers"[2].
> The former unfortunately didn't make it into the nand tree yet...
>
> [1]
> https://lore.kernel.org/all/703d7[email-masked]

I've had some issues since a distribution update, but I've taken the patch
locally and prepared my branch for the merge window, I cannot push to
the MTD repository right now but it will be done tonight.

Thanks,
Miquèl